/*------------------------------------------------*/
/* znakoveSady/table.c                            */

#include <stdio.h>
#include <locale.h>
#include "znaky.h"
#include "iso88592.h"
#include "windows1250.h"

/**
* Prevede bajt na neco jako "110xxxxx"
*/
char * chtobin(char ch) {
	static char binary[9];
	int i;
	unsigned char c = (unsigned char) ch;
	binary[8] = '\0';
	for (i = 7; i >= 0; i--) {
		binary[i] = (c & 1) ? '1' : '0';
		c >>= 1;	
	}
	for(i = 0; i < 7; i++) {
		if(binary[i] == '0') break;
	}
	for(i++; i< 8; i++)
		binary[i] = 'x';
	return binary;
}

int main(void) {
	size_t size, i;
	char *ch;
	setlocale(LC_ALL, "");

	size = sizeof(znaky)/sizeof(znaky[0]);

	printf("znak\tiso\twin\t[utf-8] \t(utf-8 binarni maska)\n");
	printf("****************************************************\n");
	for(i = 0; i < TABLE_LENGTH; i++) {
		printf("%s:\t%2X\t%2X\t", nazvy[i],  (unsigned char) iso88592[i], (unsigned char) windows1250[i]);
		printf("[ ");
		ch = znaky[i];
		while(*ch) {
			printf("%2X ", (unsigned char) *ch);
			ch++;
		}
		printf("]\t");
		ch = znaky[i];
		if(((unsigned char) *ch & (128+64)) != (128+64)) { //11000000 == 128+64
			printf("\t");
		}
		printf("( ");
		while(*ch) {
			printf("%s ", chtobin(*ch));
			ch++;
		}
		printf(")\n");
	}
	printf("\n");

	size = sizeof(iso88592)/sizeof(iso88592[0]);
	for(i = 0; i < size; i++) {
		if(iso88592[i] != windows1250[i]) {
			printf("Rozdil: %s: %2X vs %2X\n", nazvy[i], (unsigned char) iso88592[i], (unsigned char) windows1250[i]);
		}
	}

	return 0;
}

/*------------------------------------------------*/
